SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #MetaprogrammingTestCase
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:19'!
testShouldFailIfAskingForUnknownMethod
	self should: [AbstractA subclassesNotImplementing: #unknown] 
		 raise: Error
		 withExceptionDo: [ :anError | self assert: anError messageText = Behavior messageNotPresent].! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:22'!
testShouldListDirectSubclassesNotImplementingAbstractMethod
	| subclasses |
	subclasses := AbstractB subclassesNotImplementing: #anAbstractMethod.
	self assert: subclasses size = 1.
	self assert:  (subclasses includes: AbstractSubclassB).! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:16'!
testShouldListNoClasesOnAbstractMethodIfNoSubclasses
	| subclasses |
	subclasses := AbstractA subclassesNotImplementing: #anAbstractMethod.
	self assert: subclasses isEmpty.! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:16'!
testShouldListNoClasesOnImplementedMethod
	| subclasses |
	subclasses := AbstractA subclassesNotImplementing: #aConcreteMethod.
	self assert: subclasses isEmpty.! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:08'!
testShouldNotListAbstractSubclassesNotImplementingMethod
	| subclasses |
	subclasses := AbstractC subclassesNotImplementing: #anAbstractMethod.
	self assert: (subclasses includes: AbstractSubclassC) not.! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:14'!
testShouldNotListNestedSubclassesImplementingAbstractMethod
	| subclasses |
	subclasses := AbstractC subclassesNotImplementing: #anAbstractMethod.
	self deny: (subclasses includes: NestedConcreteSubclassC).! !

!MetaprogrammingTestCase methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:20'!
testShouldNotListNestedSubclassesWithInheritedImplementation
	| subclasses |
	subclasses := AbstractC subclassesNotImplementing: #anotherAbstractMethod.
	self assert: subclasses isEmpty.! !

!Behavior class methodsFor: '*Metaprogramacion' stamp: 'pb 6/19/2013 19:47'!
messageNotPresent
	^'this class does not respond to this message'! !

!Behavior methodsFor: '*Metaprogramacion' stamp: 'JuanEdi 6/19/2013 21:11'!
concreteSubclasses
	^ self allSubclasses select: [ :aSubclass | aSubclass subclasses isEmpty ].! !

!Behavior methodsFor: '*Metaprogramacion' stamp: 'JuanEdi 6/19/2013 21:37'!
subclassesNotImplementing: aMessageSelector 
	| classesToReturn |
	
	(self methodDictionary includesKey: aMessageSelector) ifFalse: [
		self error: Behavior messageNotPresent 
	].
	
	classesToReturn := Set new.
	
	(self concreteSubclasses) do: [ :aConcreteSubclass |
		aConcreteSubclass classAndMethodFor: aMessageSelector 
							 do: [ :implementingClass :compiledMethod |
									compiledMethod isAbstract ifTrue: [ classesToReturn add: aConcreteSubclass ]
							 ]
							 ifAbsent: [ "Ya chequeamos que self contenga una implementacin" ] 
	].

	^ classesToReturn.! !

Object subclass: #AbstractA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractA methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:16'!
aConcreteMethod
! !

!AbstractA methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:09'!
anAbstractMethod
	self subclassResponsibility ! !

Object subclass: #AbstractB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractB methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:19'!
anAbstractMethod
	self subclassResponsibility ! !

AbstractB subclass: #AbstractSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

AbstractB subclass: #ConcreteSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteSubclassB methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:37'!
anAbstractMethod! !

Object subclass: #AbstractC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:07'!
anAbstractMethod
 	self subclassResponsibility.! !

!AbstractC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod
 	self subclassResponsibility.! !

AbstractC subclass: #AbstractSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod
! !

AbstractSubclassC subclass: #NestedConcreteSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!NestedConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:12'!
anAbstractMethod
 	! !

AbstractC subclass: #ConcreteSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:12'!
anAbstractMethod
 	! !

!ConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod! !
